declare module "asar-integrity" {
  import BluebirdPromise from "bluebird-lst"

  export interface AsarIntegrityOptions {
    /**
     * Allows external asar files.
     *
     * @default false
     */
    readonly externalAllowed?: Boolean
  }

  export interface AsarIntegrity extends AsarIntegrityOptions {
    checksums: {
      [key: string]: string
    }
  }

  export function computeData(resourcesPath: string, options?: AsarIntegrityOptions | null): Promise<AsarIntegrity>

  export function hashFile(file: string, algorithm: string, encoding?: "hex" | "base64" | "latin1"): BluebirdPromise<string>
}

